pro get_csv_date,timestamp,month, day, year, hour, minute, second

;Note: The time stamp in MadgeTech csv file corresponds to the number of
;      days and fraction of days since midnight on December 30th, 1899. 

jday0=julday(12,30,1899,0,0,0)
jday=timestamp+jday0
caldat,jday, month, day, year, hour, minute, second  

;print, jday ,  month, day, year, hour, minute, second  

end
       


function julday_wolff, year, month, day, VERBOSE=verbose
; ***********************************************************************
; *                  Calendar to Julian day                             *
; ***********************************************************************
; * Program written by: David B. Wolff                                  *
; ***********************************************************************
        verbose = 0
        if(KEYWORD_SET(verbose)) then verbose=1
        daytab = intarr(2,13)
        daytab(0,*) = [0, 31, 59, 90, 120, 151, 181, 212, 243, 273, 304, 334, 365]
        daytab(1,*) = [0, 31, 60, 91, 121, 152, 182, 213, 244, 274, 305, 335, 366]
        leap = 0
        if( ((year mod 4) eq 0) and ((year mod 100) ne 0) $
                or ((year mod 400) eq 0) ) then leap=1
        jday = day + daytab(leap,month-1)

        return,jday
        end




pro convert_csv_txt, csv_file, YYYY
;
; This is to convert MadgeTech CSV data to gag format
; Written by Jianxin Wang ,SSAI/NASA on Feb 28, 2014
;
;path='/d2/ftp/pub/Wallops_PRF/Gauge/TB_Data/Backups2014-10-13(1447)/'


filebase=file_basename(csv_file,'.txt')
a=strsplit(filebase,'_|-',/extract,/regex)
gname=strupcase(a[0])
ymd=a[3]+a[1]+a[2]

;  get site loc
matched=0
line=''
;loc=strarr(13)
;tip=strarr(13)
openr, lun, 'WFF_loc.dat',/get_lun
readf,lun,line
while (not eof(lun)) do begin
    readf,lun,line
    a=strsplit(line,/extract)
    id=a[0]
    ;loc[id*1]=line
    type=a[5]+' '+a[7]+a[8]
    lat=a[3]
    lon=a[2]
    ; A411 (007) changed location on 10/07/2014
    ;if (id eq '0007' and YYYY ge '2015') then loc[id*1]=strmid(line, 0, 89) 
 ;   tip[id*1]=a[7]
    tip=a[7]
    if (gname eq a[1]) then begin
        matched=1
        break       
    endif
endwhile

if(matched eq 0) then begin
    print, '!! No match in the site list for gauge name: '+gname +'.  Stop to check!'
    Loc='  No loc data'
    stop
endif

free_lun,lun


;0007 A411 (-75.46378, 37.94422), moved from (-75.470806, 37.934375) on 7 Oct 2014
; convert cvs to plain text format
mod_dir='MOD/'+YYYY+'/'
if (file_test (mod_dir,/directory ) eq 0) then file_mkdir, mod_dir
mod_file=mod_dir+'WFF'+id+'_'+gname+'_'+ymd+'.mod'
print, 'Writing to '+mod_file
openw,  lun_mod, mod_file,/get_lun
printf, lun_mod, YYYY+' WFF'+id+' '+gname+' '+type
printf, lun_mod, 'Year Mon Day Jday Hr Min Sec Rain[mm]   Lat        Lon'

openr,lun_csv, csv_file,/get_lun
while (not eof(lun_csv)) do begin
    readf,lun_csv,line
    a=strsplit(line,/extract,count=n)
        
    if (n eq 6) then begin
        if(a[2] eq '+1' and a[3] eq '0' and a[4] eq '&B10000000'  ) then begin
            time=a[1]*1.D
            get_csv_date, time, month, day, year, hour, minute, second
            
            jd=julday_wolff(year,month,day)
            if (year le 2014 and jd le 280 and id eq '0007') then begin
                lat=37.934375D
                lon=-75.470806D
            endif

            if (year eq YYYY*1) then begin
                printf, lun_mod, year,month, day, jd, hour, minute, round(second), tip, lat,lon, $
                    format='(i4,2(2x,i02),2x,i03,1x,i02,2(2x,i02),1x,a6, f10.5,1x, f10.5)'
            endif
            ;if (year eq 2013) then print, year,month, day, jd, hour, minute, second
        endif
        
    endif
endwhile

free_lun,lun_csv
free_lun,lun_mod


end
