pro proc_2a56,year

; Split up each of the given annual gmin files into monthly 2A56 files.

; Written by Jianxin Wang,  NASA/GSFC/613.1/SSAI      
; Feb 19, 2014
;

gauge_network='WFF'

dir_2a56='2A56/'+year
if (file_test (dir_2a56,/directory ) eq 0) then file_mkdir, dir_2a56

data=strarr(12,31L*24*60) 
rec=lonarr(12)    ; # of records in each month
time=strarr(12)
btime=strarr(12)  ; data beginning time of each month
line=''

gminwc='GMIN/'+year+'/*.gmin'
files=file_search(gminwc,count=ngf)

for i=0,ngf-1 do begin   ; all gauges
    rec(*)=0
;    data(*,*)='missing'
;    time(*)='missing'
;    btime(*)='missing'

    fgmin=files[i]
    print, "Split "+fgmin+" into monthly files." 
    openr, lun_gmin, fgmin,/get_lun
    
    readf,lun_gmin,line
    
     a=strsplit(line,' ',/extract)
;    na=n_elements(a)
;    site=a[1]
     gid=strmid(a[2],3)
    
    header='2A-56 '+strmid(line,4)
;    for j=1,na-1 do header+=a[j]+' '

    while(not eof(lun_gmin)) do begin
        readf,lun_gmin,line        
        a=strsplit(line,' ',/extract)
        year=a[0]
        mon=a[1]
        mday=a[2]
        hh=a[4]
        mm=a[5]
        imon=mon*1-1
        
        rec[imon]=rec[imon]+1 
        irec=rec[imon]-1
        data[imon,irec]=line
        ;data[imon,irec]=strmid(line,0,31)
        time[imon]=mon+'/'+mday+'/'+year+' '+hh+':'+mm          
        if(irec eq 0) then btime[imon]=time[imon]
    endwhile
    free_lun,lun_gmin
    
    for imon=0,11 do begin
        mon=string(format='(i02)',imon+1)
        if(rec[imon] gt 0) then begin 
            f2a56=dir_2a56+'/2A56_'+gauge_network+gid+'_'+year+mon+'.asc'
            print, "      ==> ",f2a56
    
            openw,lun_2a56, f2a56,/get_lun
        
            printf,lun_2a56, header+' '+btime[imon]+' '+time[imon]
            for irec=0,rec[imon]-1 do begin
                printf,lun_2a56, data[imon,irec]
            endfor
    
            free_lun,lun_2a56
        endif

    endfor

endfor



end
