pro proc_gag, YYYY

;YYYY='2014'
ngauges=12

path='RAW/'+YYYY+'/'
wc=path+'*-*.txt'
files= file_search(wc, count=nf)

; 1) convert each raw cvs file to plain text file
for i=0,nf-1 do begin
    print, 'Reading '+files[i]
    convert_csv_txt, files[i],YYYY
endfor

;  2) merge mod files to 1 yearly file per gauge with no duplicate data
rain=fltarr(366L*24*3600) 
lat =dblarr(366L*24*3600)
lon=lat
line=''  & header1=''  & header2 =''

for id=1,ngauges do begin
    sid=string(id, format='(i04)')
    wc='MOD/'+YYYY+'/WFF'+sid+'*.mod'
    mod_files= file_search(wc, count=nf)   ; files from same gauge

    if nf eq 0 then goto, next_id
    rain[*]=-9.99
    for i=0,nf-1 do begin
        print,'Reading '+mod_files[i]
        openr, lun, mod_files[i], /get_lun
        a=strsplit(mod_files[i],'_',/extract)
        gname=a[1]
        readf, lun, header1
        readf, lun, header2
        iline=0L
        while(not eof(lun)) do begin
            readf, lun,line
            a=strsplit(line,/extract)
            jday=a[3]
            h=a[4]
            m=a[5]
            s=a[6]
            seconds=(jday-1)*3600L*24+h*3600L+m*60+s
            rain[seconds]=a[7]*1. 
            lat[seconds]=a[8]
            lon[seconds]=a[9]
            iline++
        endwhile
        free_lun,lun
    endfor

    if iline  eq 0 then goto, next_id

    ; QC according to field log
       ;disregard tips from 14:14 to 14:15 on Pad3. 10mar2014
    if (YYYY eq '2014' and id eq 3)  then rain[5926440:5926500]=0.0
        
    ;bal1 test tips started @ 1412 UTC, Mar 21,  not accurate, 
    ;data show 
    ;2014  03  21  080  14  06  38  0.254
    ;2014  03  21  080  14  06  40  0.254
    ;2014  03  21  080  14  06  42  0.254
    ;2014  03  21  080  14  06  45  0.254
    ;2014  03  21  080  14  06  47  0.254
    if (YYYY eq '2014' and id eq 12)  then rain[6876360:6876420]=0.0

    ;H201 test tips started @ 1501 UTC, Mar 21, not accurate,
    ;remove following records
    ;2014  03  21  080  14  57  26  0.254
    ;2014  03  21  080  14  57  28  0.254
    ;2014  03  21  080  14  57  31  0.254
    ;2014  03  21  080  14  57  33  0.254
    ;2014  03  21  080  14  57  35  0.254
    if (YYYY eq '2014' and id eq 11)  then rain[6879420:6879480]=0.0

    gag_dir='GAG/'+YYYY+'/'
    if (file_test (gag_dir,/directory ) eq 0) then file_mkdir, gag_dir
    gag_file=GAG_DIR+'WFF'+sid+'_'+gname+'_'+YYYY+'.gag'
    print,'Writing to '+gag_file
    openw,lun,gag_file, /get_lun 
    printf, lun, 'GAG '+header1
    printf, lun, header2

    inx=where(rain gt 0, c, /null)
    for i=0L, c-1 do begin
        isec=inx[i]
        get_dhms_from_sec, isec, jday, hour, minute, second
        get_calendar_date,YYYY*1, jday,month,day

        ;if month gt '10' then print, lat[seconds], lon[seconds]
        printf, lun, YYYY,month, day, jday, hour, minute, second,rain[isec], $
            lat[isec], lon[isec], $
            format='(a4,2(2x,i02),2x,i03,1x,i02,2(2x,i02),1x,f6.3,f10.5,1x,f10.5)'
    endfor 
    
    free_lun,lun

    next_id:

endfor  ; gauge

;  3)  qc gag
res=0.254     ; This is 0.01" for all WFF gauges
qc_threshold=10.15   ; remove data if >= 40 tip/min 
gag_dir='GAG/'+YYYY+'/'
files= file_search(gag_dir+'*gag', count=nf)
for i=0, nf-1 do begin
    qc_gag,files[i],f,resolution,qc_threshold
endfor



end
