pro proc_gmin, year

;#########################################################################  
;## Generate yearly GMIN files from daily gag files for each WFF gauge   #
;## Cubic Spline is performed for each rain event (gap<=15 min)          #
;## Input (daily gag files for the year): rain (in) at each rainy        #
;##      minute during an event                                          #
;## Output (yearly gmin file): 1-min rain rates (mm/hr)                  #
;##                                                                      #
;#########################################################################

;year='2014'
resolution=0.254     ; 0.01" for all WFF gauges
qc_threshold=10.15   ; remove data if >= 40 tip/min 
ng=12  ; 12 gauges


gmin_dir='GMIN/'+year+'/'
gag_dir='GAG_QCed/'+year+'/'
if (file_test (gmin_dir,/directory ) eq 0) then file_mkdir, gmin_dir

files= file_search(gag_dir+'*gag', count=nf)

for i=0, nf-1 do begin
    filebase=file_basename(files[i],'.gag')
    a=strsplit(filebase,'_',/extract)
    gmin_header=get_event(files[i])
    gmin_header='GMIN'+ strmid(gmin_header,3)
    gmin_file=gmin_dir+ filebase + '.gmin'
    spline_interp,resolution,gmin_file,gmin_header,qc_threshold

endfor


end
